<?php
/*========================================================================*\
|| ###################################################################### ||
|| # vBCMS Version 2.6.8
|| # ------------------------------------------------------------------ # ||
|| # Copyright  2002 - 2009 Reuter & Bloe GbR.                          ||
|| # ------------------- VBCMS IS NOT FREE SOFTWARE ------------------- # ||
|| # http://www.vbdesigns.de | http://www.vbdesigns.de/license.html     # ||
|| # ------------------------------------------------------------------ # ||
|| # Warning: Change the file only if you know what you do!             # ||
|| # Warnung: ndern Sie die Datei nur, wenn Sie wissen was Sie tun!    # ||
|| ###################################################################### ||
\*========================================================================*/

/**
* Class to handle the vBCMS output
*
* @package	vBCMS 2.6.8
* @version	$Revision: 1666 $
* @date		$Date: 2009-10-27 15:13:03 +0100 (Di, 27. Okt 2009) $
* @Author   $Author: Christian $
*/
class vBCMS_fetch_components
{
        /**
        * vBulletin objects
        *
        * @var	vB_Registry
        * @var	vB_Database
        */
        var $registry = null;
        var $db       = null;

        /**
    	* List of Modules.
    	*
    	* @var	array
    	*/
        var $global_modules;

    	/**
    	* Array for the global Modules
    	*
    	* @var array
    	*/
        var $portal_array = array();
        
    	/**
    	* Array for the cachefiles from modules
    	*
    	* @var array
    	*/        
		var $cachefile = array();
		
    	/**
    	* Array for the Modules we don't want to cache for guests, for session thinks basket etc.
    	*
    	* @var array
    	*/		
		var $dontcache = array();
		
		var $makecache = false;
		
    	/**
    	* Put a string to the $portal_array, this is for the custom scripts (vBCMS_content, lexicon, linklist, etc.).
    	* The string can be sortet (vertical, horizontal and over or under the global modul)
    	*
    	* @var array
    	*/
        var $custom_string;

    	/**
    	* Set customboxposition for external module (Left|Right|Middle)
    	*
    	* @var int
    	*/
        var $custom_horizontal;

    	/**
    	* Set customboxposition for external module (vertical)
    	*
    	* @var int
    	*/
        var $custom_vertical;

    	/**
    	* Set customboxposition for external module when $custom_vertical == false (vertical)
    	*
    	* @var int
    	*/
        var $custom_no_vertical = false;

    	/**
    	* Set customboxposition for external module (over or under the module)
    	*
    	* @var int
    	*/
        var $custom_moduleposition;

    	/**
    	* Set customboxposition active
    	*
    	* @var int
    	*/
        var $custom_active = false;

    	/**
    	* Cancel the get_modules() function when no modules ordered and errors are true.
    	*
    	* @var bool
    	*/
        var $error = false;

    	/**
    	* The <body> element
    	* Example in showthread.php == <body onload="if (is_ie || is_moz) { fetch_object('currentPost').scrollIntoView(true); }">
    	* See method delete_content
    	*
    	* @var str
    	*/
        var $vbcms_bodytag = '<body>';

    	/**
    	* Metakeywords Objekt
    	*
    	* @var str
    	*/
        var $metakeywords = '';

    	/**
    	* Metadescription Objekt
    	*
    	* @var str
    	*/
        var $metadescription = '';

    	/**
    	* Metatitle Objekt
    	*
    	* @var str
    	*/
        var $metatitle = '';

     	/**
    	* Tableleftcolum Objekt
    	*
    	* @var str
    	*/
        var $tableleftcolum = '186px';

    	/**
    	* Tableleftcolum Objekt
    	*
    	* @var str
    	*/
        var $tablerightcolum = '186px';

    	/**
    	*
    	* Contsructor
    	*
        * @param    array $registry-> objekt
    	*
    	*/
        function vBCMS_fetch_components(&$registry)
	    {
	            // Set registry and db object
                if(is_object($registry))
                {
                        $this->registry =& $registry;

                        if(is_object($registry->db))
                        {
                                $this->db =& $registry->db;
                        }else{
                                trigger_error('Database object is not an object', E_USER_ERROR);
                        }
                }else{
                        trigger_error('Registry object is not an object', E_USER_ERROR);
                }
        }
     	/**
    	* delete_cache
    	*
        * @param    string   
    	*
    	* @return   
    	*/
        function delete_cache($folder = '/vbcms_areas/vbcms_custom_content/cache/')
        {
			if (!$GLOBALS['vbulletin']->userinfo['userid'] AND defined('SCRIPTGLOBAL') AND $this->registry->vbcmsoptions['vbcms_cache'])
			{       
				if (!function_exists('rec_rmdir'))
				{
					include_once(DIR . '/includes/vbcms_area_functions.php');
				}
				rec_rmdir(DIR . $folder); 
			}
        }
    	/**
    	* Load the vBCMS area and Handle the Cache
    	*
        * @param    string   the request
    	*
    	* @return   bool mixed
    	*/
        function vbcms_area($request = false)
        {
                global $vbulletin, $vbcms, $db, $stylevar, $vbphrase, $vboptions, $vbcms_global, $permissions, $vbcmsoptions, $show;
				global $pagestarttime, $notices, $_noticeid, $notice_html;

                if($_REQUEST['area'] == 'vbcms')
                {
                        echo "<pre>
 +------------------+
 |       ___        | Copyright  2002 - 2009 Reuter & Bloe GbR.
 |   _  (,~ |   _   |
 |  (____/  |____)  | VBCMS IS NOT FREE SOFTWARE
 |  |||||    |||||  | http://www.vbsupport.org
 |  |||||    |||||  |
 |  |||||\  /|||||  | Email: Not
 |  |||'//\/\\`|||| |
 |  |' m' /\ `m `|  |
 |       /||\       | Made in Germany
  \_              _/
    `------------'
                        </pre>";
                        // Close DB Connection and set the who is online location
                        exec_shut_down();
                        exit;
                }

                if($this->registry->vbcmsoptions['vbcms_globalvariables'])
                {
                         foreach(explode("\r\n", $this->registry->vbcmsoptions['vbcms_globalvariables']) AS $globalvariables)
                         {
                                 global ${$globalvariables};
                         }
                }

                ($hook = vBulletinHook::fetch_hook('load_vbcms_area_start')) ? eval($hook) : false;

                $request_error = '';
                foreach($this->registry->vbcmsareas AS $area)
                {
                        if($request == $area['include'])
                        {
                                $request_error =& $area['include'];

                                if(!$area['active'])
                                {
                                         $this->get_error_message($area['areaname'], 'script_no_active');
                                         return false;
                                }else{
                                        if($area['useractive'])
                                        {
                                                if(!is_member_of($this->registry->userinfo, explode(',', $area['usergroups'])))
                                                {
                                                        $this->get_error_message($area['areaname'], 'no_permission');
                                                        return false;
                                                }
                                        }
                                        
                                        //Global needed area functions
                                        include_once(DIR . '/includes/vbcms_area_functions.php');
                                        
                                        // Cache?
                                        if(!$GLOBALS['vbulletin']->userinfo['userid'] AND defined('SCRIPTGLOBAL') AND $this->registry->vbcmsoptions['vbcms_cache'])
                                        {
                                        	$this->makecache = true;
                                        }
                                        
										if ($this->makecache)
										{
											$str = array();
											foreach($_GET AS $key => $val)
											{
												$str[] = vbcms_clean_string($val);
											}
											$this->str = implode('_', $str); 

											if(!file_exists(DIR . '/vbcms_areas/vbcms_custom_content/cache/' . $area['include'] . '/'))
											{
													@mkdir(DIR . '/vbcms_areas/vbcms_custom_content/cache/' . $area['include'] . '/', 0777);
													@chmod(DIR . '/vbcms_areas/vbcms_custom_content/cache/' . $area['include'] . '/', 0777);
											}
											if(!$this->str)
											{
												$this->str = vbcms_clean_string($area['include']);
											}
											$this->str = $area['include'] . '/' . md5($this->str);
                                        }
										if (
											$this->makecache
											   AND
											@file_exists(DIR . '/vbcms_areas/vbcms_custom_content/cache/' . $this->str)
											   AND
											filemtime(DIR . '/vbcms_areas/vbcms_custom_content/cache/' . $this->str) + $this->registry->vbcmsoptions['vbcms_cachetime'] >= time()
										)
										{
											@ob_start();
											include(DIR . '/vbcms_areas/vbcms_custom_content/cache/' . $this->str);
                                            $output = @ob_get_contents();
                                            @ob_end_clean();
                                            								
											if($this->registry->debug)
											{
												$pageendtime = microtime();
												$starttime = explode(' ', $pagestarttime);
												$endtime = explode(' ', $pageendtime);

												$totaltime = $endtime[0] - $starttime[0] + $endtime[1] - $starttime[1];
												$output .=  
													"Page Generation: $totaltime seconds <br />
													" . (function_exists('memory_get_usage') ? "Memory Usage:  " . number_format(memory_get_usage() / 1024) . 'KB' : '') . "
												    <br /> Queries Executed: " . $this->registry->db->querycount . " 
												";
                                            }
                                            
											//TO DO we muss check when the session has a change basket etc
											if ($this->registry->options['gzipoutput'] AND !headers_sent())
											{
												$output = fetch_gzipped_text($output, $this->registry->options['gziplevel']);

												if ($this->registry->donegzip)
												{
													@header('Content-Length: ' . strlen($output));
												}
											}
											if (defined('NOSHUTDOWNFUNC'))
											{	
												exec_shut_down();
											}
											echo $output;
											exit;                                        
										}

                                        $this->metakeywords =& $area['metakey'];
                                        $this->metadescription =& $area['metadesc'];
                                        
										if ($area['titlephrase'] AND $vbphrase[$area['areaname']])
										{
											$area['areaname'] = $vbphrase[$area['areaname']];
										}
                                       
                                        $this->metatitle =& $area['areaname'];

                                        $this->tableleftcolum =& $area['leftcolum'];
                                        $this->tablerightcolum =& $area['rightcolum'];

                                        $this->get_global_modules($area['modules'], true);

                                        if($area['buffer'])
                                        {
                                                @ob_start();
                                                require_once(DIR . '/vbcms_areas/' . $area['include'] . '.php');
                                                $outputbuffer = @ob_get_contents();
                                                @ob_end_clean();

                                                $this->get_custom_position($outputbuffer);
                                                $this->vbcms_output();
                                                unset($outputbuffer);

                                        }else{ 
                                                require_once(DIR . '/vbcms_areas/' . $area['include'] . '.php');
                                        }
                               }
                               break;
                               return true;
                        }
                }

                if(!$request_error)
                {
                       $this->get_error_message('', 'bad_request');
                       return false;
                }

                ($hook = vBulletinHook::fetch_hook('load_vbcms_area_end')) ? eval($hook) : false;

                unset($area, $request_error);
        }

    	/**
    	* Set the positon for not global modules (vBCMS_content, lexicon, linklist, etc.)
    	*
        * @param    string   with the content
        * @param    int      horizontal position (left == 1, middle == 0, right == 2)
        * @param    int      vertical position (is dependent from module id)
        * @param    int      put the customstring over or under the module (1 == over, 2 == under)
        * @param    boolean  this cleans the customstring ($header, $headinclude, $footer etc.)
    	*
    	*/
        function get_custom_position(&$mystring, $horizontal = 0, $vertical = false, $moduleposition = 1, $delete = false)
        {
                if($mystring)
                {
                        $this->custom_active = true;

                        if($delete == true)
                        {
                                $this->custom_string =& $this->delete_content($mystring);
                        }else{
                                $this->custom_string =& $mystring;
                        }

                        if($vertical == false)
                        {
                                $this->custom_no_vertical = true;
                                $this->custom_horizontal =& $horizontal;
                        }else{
                                $this->custom_horizontal =& $horizontal;
                                $this->custom_vertical =& $vertical;
                                $this->custom_moduleposition =& $moduleposition;
                        }
                        ($hook = vBulletinHook::fetch_hook('load_custom_position')) ? eval($hook) : false;
                }
        }

    	/**
    	* Set the moduleids (1,2,3,6 or whatever) and make break (error) when no modules are setting
    	*
        * @param    array   order modules
        * @param    boolean true or false for errors
    	*
    	* return    string with moduleids (1,2,3,6 or whatever) or boolean error
    	*/
        function get_global_modules($modules = '', $errors = false)
        {
                if(empty($modules) AND $errors)
                {
                        $this->error = true;
                        return $this->error;
                }else{
                        $this->global_modules = explode(',', $modules);
                        return $this->global_modules;
                }
                ($hook = vBulletinHook::fetch_hook('load_global_modules')) ? eval($hook) : false;
        }

    	/**
    	* Load modules and make output
    	*
        * @param    int   // TO DO
        * @param    int   // TO DO
    	* @param    int   // TO DO
    	*
    	* return    complete output with module and customstrings (superglobal)
    	*/
        function vbcms_output($modulid = false, $customposition = false, $isactive = false) // TO DO
        {
                global $vbulletin, $db, $vbphrase, $vbcollapse, $stylevar, $vboptions, $pmbox, $login, $navbits, $navbar, $show, $template_hook, $notifications_total, $notifications_menubits, $ad_location, $notices, $thread;
                global $header, $headinclude, $footer, $permissions, $perms, $gobutton, $forumbit, $foruminfo, $imodcache, $pagenumber;
                global $portal_array, $module_row, $vbcms_global, $navlinks, $where, $vbcmsoptions, $modulprocess_start, $modulprocess_end;

                // Global some variables that set in the setting vbcms_globalvariables
                if($this->registry->vbcmsoptions['vbcms_globalvariables'])
                {
                         foreach(explode("\r\n", $this->registry->vbcmsoptions['vbcms_globalvariables']) AS $globalvariables)
                         {
                                 global ${$globalvariables};
                         }
                }

                ($hook = vBulletinHook::fetch_hook('load_vbcms_output_start')) ? eval($hook) : false;

                // Put infos in the $vbcms_global array
                $vbcms_global['bodytag']                  =& $this->vbcms_bodytag;
                $vbcms_global['left_colum']               = ((defined('SCRIPTGLOBAL')) ? $this->tableleftcolum : $vbulletin->options['vbcms_forum_leftcolum']);
                $vbcms_global['right_colum']              = ((defined('SCRIPTGLOBAL')) ? $this->tablerightcolum : $vbulletin->options['vbcms_area_rightcolum']);
                if (defined('SCRIPTGLOBAL'))
                {
                	$vbcms_global['meta_keywords']            = '<meta name="keywords" content="' . (($this->metakeywords) ? $this->metakeywords : $this->registry->options['keywords']) . '" />';
                	$vbcms_global['meta_description']         = '<meta name="description" content="' . (($this->metadescription) ? $this->metadescription : $this->registry->options['description']) . '" />';
                }
                $vbcms_global['lt_modul_custom']          =& $isactive;
                $vbcms_global['lt_modul_custom_position'] =& $customposition;

                // Global permissions to view Polls, Forums, News for the modules
                $excl = $forumpermissions_v = array();
                foreach($this->registry->forumcache AS $forum)
                {
                        $forumpermissions_v[$forum["forumid"]] = fetch_permissions($forum['forumid']);

                        if((!($forumpermissions_v[$forum["forumid"]] & $this->registry->bf_ugp_forumpermissions['canview']) AND !$this->registry->options['showprivateforums']) OR !($forumpermissions_v[$forum["forumid"]] & $this->registry->bf_ugp_forumpermissions['canviewothers']))
                        {
                                 if($forum['forumid'])
                                 {
                                         $excl[] = $forum['forumid'];
                                 }
                        }
                }
                $vbcms_global['forumpermissions'] = implode(',', $excl);
                unset($forum, $forumpermissions_v, $excl);

                if($this->registry->userinfo['userid'] AND !in_array(THIS_SCRIPT, array('index', 'forumdisplay', 'search', 'moderator')))
                {
                        // Make the moderatorcache for can_moderate() function
                        include_once(DIR . '/includes/functions_forumlist.php');
                        cache_moderators($this->registry->userinfo['userid']);
                }

                if($this->error)
                {
                        if($this->custom_active AND $this->error)
                        {
                                // Later
                        }else{
                                eval(standard_error('Bitte geben Sie mindestens ein Modul an', $displayCommon));
                        }
                }

                include_once(DIR . '/includes/class_bbcode.php');
                $bbcode_class =& new vB_BbCodeParser($this->registry, fetch_tag_list());

                ($hook = vBulletinHook::fetch_hook('load_vbcms_output_process_start')) ? eval($hook) : false;

                if($vbulletin->debug)
                {
                        $modulprocess_start = explode(' ', microtime());
                        define('VBCMSMODUL_TIME', true);
                }

                include_once(DIR . '/includes/vbcms_module_functions.php');

                foreach($this->registry->vbcmsportal AS $module_row)
                {
                        $collapse    = $vbcollapse["collapseobj_module_" . $module_row['id'] . ""];
                        $collapseimg = $vbcollapse["collapseimg_module_" . $module_row['id']  . ""];

                        if($this->global_modules AND in_array($module_row['id'], $this->global_modules))
                        {
                                if(is_member_of($this->registry->userinfo, explode(',', $module_row['user_groups'])))
                                {
                                        $module_row['cansee_global_modules'] = true;
                                }

                                if($module_row['cansee_global_modules'] === true)
                                {
                                        if($module_row['colum'] == 1)
                                        {
                                                $vbcmsoptions['show_hide_grafic_left'] = true;
                                        }
                                        if($module_row['colum'] == 2)
                                        {
                                                $vbcmsoptions['show_hide_grafic_right'] = true;
                                        }

                                        if($module_row['moduletype'] == 'php_file')
                                        {
                                                if($module_row['buffer'])
                                                {
                                                        @ob_start();
                                                        require_once(DIR . '/vbcms_global_modules/' . $module_row['modulname'] . '.php');
                                                        $this->portal_array["$module_row[id]"]["$module_row[colum]"] = @ob_get_contents();
                                                        @ob_end_clean();
                                                }
                                                else
                                                {
                                                        require_once(DIR . '/vbcms_global_modules/' . $module_row['modulname'] . '.php');
                                                }
                                                
                                        	if($this->dontcache[$module_row['id']] === true AND $this->makecache)
                                        	{
                                        		$tempfile = file_get_contents(DIR . '/vbcms_global_modules/' . $module_row['modulname'] . '.php');
                                        		$tempfile = str_replace('$this->portal_array[$module_row[' . chr(92) . chr(39) . 'id' . chr(92) . chr(39) . ']][$module_row[' . chr(92) . chr(39) . 'colum' . chr(92) . chr(39) . ']]', '$outputs', $tempfile);
                                        		$this->portal_array["$module_row[id]"]["$module_row[colum]"] = '<!-- nocache' . $module_row[id] . ' -->' . $this->portal_array["$module_row[id]"]["$module_row[colum]"] . '<!-- /nocache' . $module_row[id] . ' -->';
                                        		$this->cachefile[$module_row['id']] = $tempfile . '<?php echo $outputs; unset($outputs); ?>';
                                        	}                                                

                                        }
                                        else if($module_row['moduletype'] == 'bb_code')
                                        {

                                                if($module_row['htmlbbcodes'])
                                                {
                                                        $module_row['modulebbcode'] = addslashes($module_row['modulebbcode']);
                                                        $module_row['modulebbcode'] = str_replace(array("\\'", "['","']"), array("'", "[", "]"),  $module_row['modulebbcode']);
                                                        eval('$module_row[modulebbcode] = "' . $module_row['modulebbcode']. '";');
                                                }else{
                                                        $module_row['modulebbcode'] = $bbcode_class->do_parse($module_row['modulebbcode']);
                                                }
                                                eval('$this->portal_array["$module_row[id]"]["$module_row[colum]"] = "' . fetch_template($module_row['template']) . '";');
                                                $this->portal_array["$module_row[id]"]["$module_row[colum]"] = str_replace('src="images/smilies/', 'src="' . $this->registry->vbcmsoptions['vbcms_forumfolder'] . '/images/smilies/', $this->portal_array["$module_row[id]"]["$module_row[colum]"]);
                                        }else{

                                                eval('$this->portal_array["$module_row[id]"]["$module_row[colum]"] = "' . fetch_template($module_row['template']) . '";');
                                        }
                                }
                        }
                }
                
                if($vbulletin->debug)
                {
                        $modulprocess_end = explode(' ', microtime());
                }

                unset($bbcode_class, $module_row, $collapse, $collapseimg);

                // ====================[ draw nav bar ]======================================

                if(!$navbits['lastelement'])
                {
                        if(!$vbcms_global['headtitle'])
                        {
                                $navbits[''] =& $this->metatitle;
                                $vbcms_global['headtitle'] =& $this->metatitle;
                        }
                        else
                        {
                                $navbits[''] =& $vbcms_global['headtitle'];
                        }
                }
                else
                {
                        $vbcms_global['headtitle'] = (($thread['title']) ? $thread['prefix_plain_html'] . ' ' . $thread['title'] : $navbits['lastelement']);
                        $vbcms_global['headtitle'] = str_replace(array('<span class="normal">', '</span>'), '', $vbcms_global['headtitle']);
                }

                if($this->registry->vbcmsoptions['vbcms_navbar'] == 1 AND defined('SCRIPTGLOBAL'))
                {
                        $navbits = construct_navbits($navbits);
                        eval('$navbar = "' . fetch_template('navbar') . '";');
                        
                        if($this->makecache)
                        {
                       		 $navbar = preg_replace('/\<form action="profile.php\?do=dismissnotice" method="post" id="notices"\>(.+)\<\/form\>/sU', '<!-- nocachenotice -->\1<!-- /nocachenotice -->', $navbar);
                        	$this->cachefile['notice'] = '<?php echo ($show[\'notices\'] ? "' . addslashes('<form action="profile.php?do=dismissnotice" method="post" id="notices">
<input type="hidden" name="do" value="dismissnotice" />
<input type="hidden" name="securitytoken" value="$bbuserinfo[securitytoken]" />
<input type="hidden" id="dismiss_notice_hidden" name="dismiss_noticeid" value="" />
<input type="hidden" name="url" value="$return_link" />
	<table class="tborder" cellpadding="$stylevar[cellpadding]" cellspacing="$stylevar[cellspacing]" border="0" width="100%" align="center">
	<tr>
		<td class="thead">$vbphrase[notices]</td>
	</tr>
	<tr>
		<td class="alt1">
			$notices
		</td>
	</tr>
	</table>
	<br />
</form>') . '" : ""); ?>';
						}
                }


                if($this->custom_active)
                {
                        // Keep Cool :-)
                        if($this->custom_no_vertical)
                        {
                                $set_over['custom']["$this->custom_horizontal"] =& $this->custom_string;
                                $this->portal_array = $set_over + $this->portal_array;
                        }else{
                                switch($this->custom_moduleposition)
                                {
                                        case 1:
                                        {
                                                $this->portal_array["$this->custom_vertical"]["$this->custom_horizontal"] = $this->custom_string . $this->portal_array["$this->custom_vertical"]["$this->custom_horizontal"];
                                        }
                                        break;
                                        case 2:
                                        {
                                                $this->portal_array["$this->custom_vertical"]["$this->custom_horizontal"] = $this->portal_array["$this->custom_vertical"]["$this->custom_horizontal"] . $this->custom_string;
                                        }
                                        break;
                                }
                        }
                }

                ($hook = vBulletinHook::fetch_hook('load_vbcms_output_process_end')) ? eval($hook) : false;

                foreach($this->portal_array AS $key => $modul)
                {
                        $vbcms_global['left_table']   .= $modul[1];
                        $vbcms_global['right_table']  .= $modul[2];
                        $vbcms_global['middle_table'] .= $modul[0];
                }

                ($hook = vBulletinHook::fetch_hook('load_vbcms_output_end')) ? eval($hook) : false;
				
				// Cache for Guests
				if ($this->makecache)
				{
					eval('$cache = "' . fetch_template('Portal_global') . '";');
					
					if ($this->cachefile)
					{
						foreach($this->cachefile AS $key => $val)
						{
							$cache = preg_replace('/\<\!-- nocache' . $key . ' --\>(.*)\<\!-- \/nocache' . $key . ' --\>/si', $val, $cache);
						}
					}
					
				    if(@file_exists(DIR . '/vbcms_areas/vbcms_custom_content/cache/' . $this->str))
				    {
						unlink(DIR . '/vbcms_areas/vbcms_custom_content/cache/' . $this->str);
				    }
					if(!$fih = @fopen(DIR . '/vbcms_areas/vbcms_custom_content/cache/' . $this->str, "a"))
					{
							//trigger_error('Can\'t open' . DIR . '/vbcms_areas/vbcms_custom_content/cache/' . $this->str, E_USER_ERROR);
					}

					if(!@fwrite($fih, $cache))
					{
							//trigger_error('Can\'t write in' . DIR . '/vbcms_areas/vbcms_custom_content/cache/' . $this->str, E_USER_ERROR);
					}
					@fclose($fih); 
					@chmod(DIR . '/vbcms_areas/vbcms_custom_content/cache/' . $this->str, 0644);
                                        
                }
                return eval('print_output("' . fetch_template('Portal_global') . '");');
        }

    	/**
    	* Clean the $output and set the vbcms_bodytag object.
    	*
        * @param	string   content
    	*/
        function delete_content(&$content)
        {
                global $vbulletin, $header, $navbar, $footer, $headinclude, $spacer_close, $spacer_open, $debughtml, $onload;

                if($onload)
                {
                        $this->vbcms_bodytag = $delete = '<body onload="' . $onload . '">';
                }else{
                        $delete = '<body onload="">';
                }

                $content = preg_replace('/\<!DOCTYPE(.+)\<head\>|\<title(.+)title\>|\<\/head\>|\<body\>|\<\!--start debug html(.+)end debug html--\>|\<!-- no cache headers(.+)end no cache headers --\>/is', '', $content);

                ($hook = vBulletinHook::fetch_hook('load_delete_content')) ? eval($hook) : false;

                return str_replace(array($header, $navbar, $footer, $headinclude, $spacer_close, $spacer_open, $delete, '</body>', '</html>'), '', $content . '<br />');
        }
    	/**
    	* Make a errormessage.
    	*
        * @param	string scriptname
        * @param    string errortype
        * @param    string more args for defaut switch args must be uses from error phrases :-)
        *
        * return    a specificated errormessage in the frontend, for all users
    	*/
        function get_error_message($script = '', $errortype = '')
        {
                global $vbulletin, $vbphrase;

                ($hook = vBulletinHook::fetch_hook('load_error_message')) ? eval($hook) : false;

                switch($errortype)
                {
                        case 'script_no_active':
                        {
                                return eval(standard_error(fetch_error('vbcms_error_no_active_x', $script), $displayCommon));
                        }
                        break;
                        case 'bad_request':
                        {
                                return eval(standard_error(fetch_error('invalidid', $vbphrase['forum'], $this->registry->options['contactuslink'])));
                        }
                        break;
                        case 'no_permission':
                        {
                                return print_no_permission();
                        }
                        break;
                        default:
                        {
                                $arg_list = func_get_args();
                                unset($arg_list[0], $arg_list[1]);
                                
                                foreach($arg_list AS $key => $val)
                                {
                                	$arg[] = $val;
                                }
                                return eval(standard_error(fetch_error($arg)));
                        }
                        break;
                }
        }
}

/*======================================================================*\
|| ####################################################################
|| # NulleD By - FintMax
|| # SVN: $RCSfile$ - $Revision: 1666 $
|| ####################################################################
\*======================================================================*/
?>