<?php
/*========================================================================*\
|| ###################################################################### ||
|| # vBCMS Version 2.6.8
|| # ------------------------------------------------------------------ # ||
|| # Copyright  2002 - 2009 Reuter & Bloe GbR.                          ||
|| # ------------------- VBCMS IS NOT FREE SOFTWARE ------------------- # ||
|| # http://www.vbdesigns.de | http://www.vbdesigns.de/license.html     # ||
|| ###################################################################### ||
\*========================================================================*/
if(!class_exists('vBCMS_fetch_components'))
{
        exit;
}

/**
* Class to do data handle payment operations for vBCMS products
*
* @package	vBCMS 2.6.8
* @version	$Revision: 1517 $
* @date		$Date: 2009-04-29 10:06:27 +0200 (Mi, 29. Apr 2009) $
*/
class hermes extends vbcms_shippings
{
        /**
    	* For the description of the objects see /includes/class_vbcms_shippings.php
    	*
    	* @var	mixed
    	*/
        var $name = 'Hermes';
        var $host = 'http://www.hermespaketshop.de/';
        var $shippingzones = array(
                'Zone 1' => array(
                        'countrys' => 'DE',
                        'scost' => '5:3.90,10:5.90,20:8.90'
                ),
                'Zone 2' => array(
                        'countrys' => 'AD,AT,BE,CZ,DK,FO,FI,FR,GR,GL,IE,IT,LI,LU,MC,NL,PL,PT,SM,SK,SE,CH,VA,GB,SP',
                        'scost' => '5:14.90,10:19.90,20:29.90'
                )
        );

		var $allowed_countrys = 'DE,AD,AT,BE,CZ,DK,FO,FI,FR,GR,GL,IE,IT,LI,LU,MC,NL,PL,PT,SM,SK,SE,CH,VA,GB,SP';

        /**
        * Constructor - checks that the registry object has been passed correctly.
        *
        * @param	(ref)  vB_Registry	Instance of the vBulletin data registry object.
        */
        function dp(&$registry)
        {
	            // Set registry and db object
                parent::vbcms_shippings($registry);
        }

        /**
        * Install the modul.
        */
        function install()
        {
                $this->db->query_write("
                        INSERT INTO " . TABLE_PREFIX . "vbcmsshippings
                        (id, name, field, active, classname, countrys, handling, defaultcheck, free, freehandling)
                        VALUES
                        (
                        '',
                        '" . $this->db->escape_string(get_class($this)) . "',
                        '" . $this->db->escape_string('') . "',
                        1,
                        '" . $this->db->escape_string(get_class($this)) . "',
                        '" . $this->db->escape_string($this->allowed_countrys) . "',
                        0,
                        0,
                        0,
                        0)
                ");
                if($this->shippingzones)
                {
                        foreach($this->shippingzones AS $key => $val)
                        {
                                $this->db->query_write("
                                        INSERT INTO " . TABLE_PREFIX . "vbcmsshippingzones
                                        (id, classname, name, countrys, scost)
                                        VALUES
                                        (
                                        '',
                                        '" . $this->db->escape_string(get_class($this)) . "',
                                        '" . $this->db->escape_string($key) . "',
                                        '" . $this->db->escape_string($val['countrys']) . "',
                                        '" . $this->db->escape_string($val['scost']) . "'
                                        )
                                ");
                        }
                }
        }

        /**
        * Uninstall the modul.
        */
        function uninstall()
        {
                $this->db->query_write("
                        DELETE FROM " . TABLE_PREFIX . "vbcmsshippings WHERE classname = '" . get_class($this) . "'
                ");
                $this->db->query_write("
                        DELETE FROM " . TABLE_PREFIX . "vbcmsshippingzones WHERE classname = '" . get_class($this) . "'
                ");
        }
}

/*======================================================================*\
|| ####################################################################
|| # NulleD By - FintMax
|| # SVN: $RCSfile$ - $Revision: 1517 $
|| ####################################################################
\*======================================================================*/
?>