<?php
/*========================================================================*\
|| ###################################################################### ||
|| # vBCMS Version 2.6.8
|| # ------------------------------------------------------------------ # ||
|| # Copyright  2002 - 2009 Reuter & Bloe GbR.                          ||
|| # ------------------- VBCMS IS NOT FREE SOFTWARE ------------------- # ||
|| # http://www.vbdesigns.de | http://www.vbdesigns.de/license.html     # ||
|| ###################################################################### ||
\*========================================================================*/
if(!class_exists('vBCMS_fetch_components'))
{
        exit;
}

/**
* Class to do data handle payment operations for vBCMS products
*
* @package	vBCMS 2.6.8
* @version	$Revision: 1517 $
* @date		$Date: 2009-04-29 10:06:27 +0200 (Mi, 29. Apr 2009) $
*/
class letter extends vbcms_shippings
{
        /**
    	* For the description of the objects see /includes/class_vbcms_shippings.php
    	*
    	* @var	mixed
    	*/
        var $name = 'Briefversand (Letter) Deutsche Post';
        var $host = 'http://www.deutschepost.de/brief_produkt';
        var $shippingzones = array(
                'Zone 1' => array(
                        'countrys' => 'DE',
                        'scost' => '0.02:0.55,0.05:0.90,0.5:1.45,1:2.20,2:3.90'
                ),
                'Zone 2' => array(
                        'countrys' => 'AD,AT,BE,CZ,DK,FO,FI,FR,GR,GL,IE,IT,LI,LU,MC,NL,PL,PT,SM,SK,SE,CH,VA,GB,SP',
                        'scost' => '0.02:0.70,0.05:1.25,0.5:3.00,1:6.00,2:14.00'
                ),
                'Zone 3' => array(
                        'countrys' => 'AL,AM,AZ,BY,BA,BG,HR,CY,GE,GI,HU,IS,KZ,LT,MK,MT,MD,NO,SI,UA,TR,YU,RU,RO,LV,EE,DZ,BH,CA,EG,IR,IQ,IL,JO,KW,LB,LY,OM,SA,SY,US,AE,YE,MA,QA,TN,PM,AF,AS,AO,AI,AG,AR,AW,AU,BS,BD,BB,BZ,BJ,BM,BT,BO,BW,BR,IO,BN,BF,BI,KH,CM,CV,KY,CF,TD,CL,CN,CC,CO,KM,CG,CR,CI,CU,DM,DO,EC,SV,ER,ET,FK,FJ,GF,PF,GA,GM,GH,GD,GP,GT,GN,GW,GY,HT,HN,HK,IN,ID,JM,JP,KE,KI,KG,KP,KR,LA,LS,MO,MG,MW,MY,MV,ML,MQ,MR,MU,MX,MN,MS,MZ,MM,NA,NR,NP,AN,NC,NZ,NI,NE,NG,PK,PA,PG,PY,PE,PH,PN,RE,KN,LC,VC,SN,SC,SL,SO,LK,SR,SZ,ZA,SG,TG,TH,TZ,TT,TO,TM,TV,VN,WF,VE,UG,UZ,UY,ST,SH,SD,TW,GQ,LR,DJ,CG,RW,ZM,ZW',
                        'scost' => '0.02:1.70,0.05:2.20,0.5:6.00,1:12.00,2:24.00'
                )
        );

        /**
        * Constructor - checks that the registry object has been passed correctly.
        *
        * @param	(ref)  vB_Registry	Instance of the vBulletin data registry object.
        */
        function letter(&$registry)
        {
	            // Set registry and db object
                parent::vbcms_shippings($registry);
        }

        /**
        * Install the modul.
        */
        function install()
        {
                $this->db->query_write("
                        INSERT INTO " . TABLE_PREFIX . "vbcmsshippings
                        (id, name, field, active, classname, countrys, handling, defaultcheck, free, freehandling)
                        VALUES
                        (
                        '',
                        '" . $this->db->escape_string(get_class($this)) . "',
                        '" . $this->db->escape_string('') . "',
                        1,
                        '" . $this->db->escape_string(get_class($this)) . "',
                        '" . $this->db->escape_string($this->allowed_countrys) . "',
                        0,
                        1,
                        0,
                        0)
                ");
                if($this->shippingzones)
                {
                        foreach($this->shippingzones AS $key => $val)
                        {
                                $this->db->query_write("
                                        INSERT INTO " . TABLE_PREFIX . "vbcmsshippingzones
                                        (id, classname, name, countrys, scost)
                                        VALUES
                                        (
                                        '',
                                        '" . $this->db->escape_string(get_class($this)) . "',
                                        '" . $this->db->escape_string($key) . "',
                                        '" . $this->db->escape_string($val['countrys']) . "',
                                        '" . $this->db->escape_string($val['scost']) . "'
                                        )
                                ");
                        }
                }
        }

        /**
        * Uninstall the modul.
        */
        function uninstall()
        {
                $this->db->query_write("
                        DELETE FROM " . TABLE_PREFIX . "vbcmsshippings WHERE classname = '" . get_class($this) . "'
                ");
                $this->db->query_write("
                        DELETE FROM " . TABLE_PREFIX . "vbcmsshippingzones WHERE classname = '" . get_class($this) . "'
                ");
        }
}

/*======================================================================*\
|| ####################################################################
|| # NulleD By - FintMax
|| # SVN: $RCSfile$ - $Revision: 1517 $
|| ####################################################################
\*======================================================================*/
?>